

#if ARDUINO >= 100
  #include "Arduino.h"
#else
  #include "WProgram.h"
#endif

#include "ProyectoSer.h"

ComPacto::ComPacto()
{
    
}

void ComPacto::iniciar(){
    pinMode(pinData, OUTPUT);
    pinMode(pinClock, OUTPUT);
    pinMode(pinLatch, OUTPUT);
    pinMode(pinOE, OUTPUT);
    pinMode(pin_vel1, OUTPUT);
    pinMode(pin_vel2, OUTPUT);
    pinMode(pin_led0, OUTPUT);
    pinMode(pin_led1, OUTPUT);
    
    pinMode(pin_sensor0, INPUT);
    pinMode(pin_sensor1, INPUT);
    pinMode(pin_sensor2, INPUT);
    pinMode(pin_sensor3, INPUT);
    pinMode( pin_sensor4, INPUT);
    
    pinMode(pin_ultrasonico_echo, INPUT);
    pinMode(pin_ultrasonico_trigger, OUTPUT);
    
    //Inicio Multiplexor
    digitalWrite(pinOE, LOW);
    digitalWrite(pinLatch, LOW);
    bitWrite (datoMultiplexor, orden_led0, true);
    bitWrite (datoMultiplexor, orden_led1, true);
    shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
    digitalWrite(pinLatch, HIGH);
    delay(1);
    digitalWrite(pinLatch, LOW);
    
    
    accion = true;
    
    delay(3000);
}
 


void ComPacto::avanzar(int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        velocidad_motor1 = _pwm;
        velocidad_motor2 = _pwm;        
        bitWrite (datoMultiplexor, orden_dir1A, true);
        bitWrite (datoMultiplexor, orden_dir1B, false);
        bitWrite (datoMultiplexor, orden_dir2A, true);
        bitWrite (datoMultiplexor, orden_dir2B, false);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        analogWrite(pin_vel2, velocidad_motor2);
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
    }
}
void ComPacto::retroceder(int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        velocidad_motor1 = _pwm;
        velocidad_motor2 = _pwm;        
        bitWrite (datoMultiplexor, orden_dir1A, false);
        bitWrite (datoMultiplexor, orden_dir1B, true);
        bitWrite (datoMultiplexor, orden_dir2A, false);
        bitWrite (datoMultiplexor, orden_dir2B, true);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        analogWrite(pin_vel2, velocidad_motor2);
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
    }
}
void ComPacto::derecha(int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        velocidad_motor1 = _pwm;
        velocidad_motor2 = _pwm;        
        bitWrite (datoMultiplexor, orden_dir1A, false);
        bitWrite (datoMultiplexor, orden_dir1B, true);
        bitWrite (datoMultiplexor, orden_dir2A, true);
        bitWrite (datoMultiplexor, orden_dir2B, false);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        analogWrite(pin_vel2, velocidad_motor2);
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
    } 
}
void ComPacto::izquierda(int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        velocidad_motor1 = _pwm;
        velocidad_motor2 = _pwm;        
        bitWrite (datoMultiplexor, orden_dir1A, true);
        bitWrite (datoMultiplexor, orden_dir1B, false);
        bitWrite (datoMultiplexor, orden_dir2A, false);
        bitWrite (datoMultiplexor, orden_dir2B, true);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        analogWrite(pin_vel2, velocidad_motor2);
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
    }
}
void ComPacto::parar(){
    if(accion){
        velocidad_motor1 = 0;
        velocidad_motor2 = 0;
        analogWrite(pin_vel1,velocidad_motor1);
        analogWrite(pin_vel2,velocidad_motor2);
    }
}

void ComPacto::avanzar(int _tiempo, int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        _tiempo = constrain(_tiempo,0,32000);
        velocidad_motor1 = _pwm;
        velocidad_motor2 = _pwm;
        bitWrite (datoMultiplexor, orden_dir1A, true);
        bitWrite (datoMultiplexor, orden_dir1B, false);
        bitWrite (datoMultiplexor, orden_dir2A, true);
        bitWrite (datoMultiplexor, orden_dir2B, false);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        analogWrite(pin_vel2, velocidad_motor2);
        
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
        delay(_tiempo);
        
        velocidad_motor1 = 0;
        velocidad_motor2 = 0;
        analogWrite(pin_vel1,velocidad_motor1);
        analogWrite(pin_vel2,velocidad_motor2);
    }
}
void ComPacto::retroceder(int _tiempo, int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        _tiempo = constrain(_tiempo,0,32000);
        velocidad_motor1 = _pwm;
        velocidad_motor2 = _pwm;
        bitWrite (datoMultiplexor, orden_dir1A, false);
        bitWrite (datoMultiplexor, orden_dir1B, true);
        bitWrite (datoMultiplexor, orden_dir2A, false);
        bitWrite (datoMultiplexor, orden_dir2B, true);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        analogWrite(pin_vel2, velocidad_motor2);
        
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
        delay(_tiempo);
        
        velocidad_motor1 = 0;
        velocidad_motor2 = 0;
        analogWrite(pin_vel1,velocidad_motor1);
        analogWrite(pin_vel2,velocidad_motor2);
    }
}
void ComPacto::derecha(int _tiempo, int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        _tiempo = constrain(_tiempo,0,32000);
        velocidad_motor1 = _pwm;
        velocidad_motor2 = _pwm;
        bitWrite (datoMultiplexor, orden_dir1A, false);
        bitWrite (datoMultiplexor, orden_dir1B, true);
        bitWrite (datoMultiplexor, orden_dir2A, true);
        bitWrite (datoMultiplexor, orden_dir2B, false);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        analogWrite(pin_vel2, velocidad_motor2);
        
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
        delay(_tiempo);
        
        velocidad_motor1 = 0;
        velocidad_motor2 = 0;
        analogWrite(pin_vel1,velocidad_motor1);
        analogWrite(pin_vel2,velocidad_motor2);
    }
}
void ComPacto::izquierda(int _tiempo, int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        _tiempo = constrain(_tiempo,0,32000);
        velocidad_motor1 = _pwm;
        velocidad_motor2 = _pwm;
        bitWrite (datoMultiplexor, orden_dir1A, true);
        bitWrite (datoMultiplexor, orden_dir1B, false);
        bitWrite (datoMultiplexor, orden_dir2A, false);
        bitWrite (datoMultiplexor, orden_dir2B, true);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        analogWrite(pin_vel2, velocidad_motor2);
        
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
        delay(_tiempo);
        
        velocidad_motor1 = 0;
        velocidad_motor2 = 0;
        analogWrite(pin_vel1,velocidad_motor1);
        analogWrite(pin_vel2,velocidad_motor2);
    }
}
void ComPacto::parar(int _tiempo){
    if(accion){
        _tiempo = constrain(_tiempo,0,32000);
        velocidad_motor1 = 0;
        velocidad_motor2 = 0;
        analogWrite(pin_vel1,velocidad_motor1);
        analogWrite(pin_vel2,velocidad_motor2);
        delay(_tiempo);
    }
}

void ComPacto::avanzar_motor1(int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        velocidad_motor1 = _pwm;
        
        bitWrite (datoMultiplexor, orden_dir1A, true);
        bitWrite (datoMultiplexor, orden_dir1B, false);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);

    }
}
void ComPacto::avanzar_motor2(int _pwm){
   if(accion){
       _pwm = constrain(_pwm,0,255);
       velocidad_motor2 = _pwm;
       bitWrite (datoMultiplexor, orden_dir2A, true);
       bitWrite (datoMultiplexor, orden_dir2B, false);
       shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
       analogWrite(pin_vel2, velocidad_motor2);
       digitalWrite(pinLatch, HIGH);
       delay(1);
       digitalWrite(pinLatch, LOW);
   }
}
void ComPacto::retroceder_motor1(int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        velocidad_motor1 = _pwm;
        bitWrite (datoMultiplexor, orden_dir1A, false);
        bitWrite (datoMultiplexor, orden_dir1B, true);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
    }
}
void ComPacto::retroceder_motor2(int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        velocidad_motor2 = _pwm;
        bitWrite (datoMultiplexor, orden_dir2A, false);
        bitWrite (datoMultiplexor, orden_dir2B, true);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel2, velocidad_motor2);
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
    }
}

void ComPacto::avanzar_motor1(int _tiempo,int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        _tiempo = constrain(_tiempo,0,32000);
        velocidad_motor1 = _pwm;
        bitWrite (datoMultiplexor, orden_dir1A, true);
        bitWrite (datoMultiplexor, orden_dir1B, false);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
        delay(_tiempo);
        velocidad_motor1 = 0;
        analogWrite(pin_vel1,velocidad_motor1);
    }
}
void ComPacto::avanzar_motor2(int _tiempo,int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        _tiempo = constrain(_tiempo,0,32000);
        velocidad_motor2 = _pwm;
        bitWrite (datoMultiplexor, orden_dir2A, true);
        bitWrite (datoMultiplexor, orden_dir2B, false);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel2, velocidad_motor2);
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
        delay(_tiempo);
        velocidad_motor2 = 0;
        analogWrite(pin_vel2,velocidad_motor2);
    }
}
void ComPacto::retroceder_motor1(int _tiempo,int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        _tiempo = constrain(_tiempo,0,32000);
        velocidad_motor1 = _pwm;
        bitWrite (datoMultiplexor, orden_dir1A, false);
        bitWrite (datoMultiplexor, orden_dir1B, true);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel1, velocidad_motor1);
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
        delay(_tiempo);
        velocidad_motor1 = 0;
        analogWrite(pin_vel1,velocidad_motor1);
    }
}
void ComPacto::retroceder_motor2(int _tiempo,int _pwm){
    if(accion){
        _pwm = constrain(_pwm,0,255);
        _tiempo = constrain(_tiempo,0,32000);
        velocidad_motor2 = _pwm;
        bitWrite (datoMultiplexor, orden_dir2A, false);
        bitWrite (datoMultiplexor, orden_dir2B, true);
        shiftOut(pinData, pinClock, MSBFIRST, datoMultiplexor);
        analogWrite(pin_vel2, velocidad_motor2);
        digitalWrite(pinLatch, HIGH);
        delay(1);
        digitalWrite(pinLatch, LOW);
        delay(_tiempo);
        velocidad_motor2 = 0;
        analogWrite(pin_vel2,velocidad_motor2);
    }
}

void ComPacto::led(int _led,int _pwm){
    if(accion){
        switch (_led) {
            case 0:
                valor_led0 = _pwm;
                analogWrite(pin_led0, valor_led0);
                break;
            case 1:
                valor_led1 = _pwm;
                analogWrite(pin_led1, valor_led1);
                break;
        }
    }
}

int ComPacto::sensor(int _sensor){
    if(accion){
        switch (_sensor) {
            case 0:
                valor_sensor0 = analogRead(pin_sensor0);
                return valor_sensor0;
                break;
            case 1:
                valor_sensor1 = analogRead(pin_sensor1);
                return valor_sensor1;
                break;
            case 2:
                valor_sensor2 = analogRead(pin_sensor2);
                return valor_sensor2;
                break;
            case 3:
                valor_sensor3 = analogRead(pin_sensor3);
                return valor_sensor3;
                break;
            case 4:
                valor_sensor4 = analogRead(pin_sensor4);
                return valor_sensor4;
                break;
            case 5:
                valor_sensor5 = analogRead(pin_sensor5);
                return valor_sensor5;
                break;
            default: 
                return 0;
        }
    }
}

int Pin8::ultrasonico(){
    if(accion){
        digitalWrite(pin_ultrasonico_trigger, LOW);
        delayMicroseconds(2);
        digitalWrite(pin_ultrasonico_trigger, HIGH);
        delayMicroseconds(10);
        digitalWrite(pin_ultrasonico_trigger, LOW);
        unsigned int auxiliar  = pulseIn(pin_ultrasonico_echo, dist_max * 58 );
        valor_ultrasonico = int( auxiliar / 58);
        valor_ultrasonico = constrain(valor_ultrasonico,0,dist_max);
        return valor_ultrasonico;
    }
}

void ComPacto::no_repetir(){
    accion = false;
}

void ComPacto::repetir(){
    accion = true;
}

